Attribute VB_Name = "mdMMVariables"
'
'Copyright (C) 2003-2005 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Form:    mdMMVariables.frm                                   *
'*Author:  Marco Magistrali - Funambol                          *
'****************************************************************

Option Explicit
Public Declare Function synchronization Lib "winmainclientdll.dll" ( _
            ByVal isSlow As String, ByVal xmlAll As String, _
            ByVal xmlNew As String, ByVal xmlMod As String, ByVal xmlDel As String, _
            ByVal folderType As String, ByVal path As String) As String
Public Declare Function endSynchronization Lib "winmainclientdll.dll" (ByVal xmlMapping As String, ByVal folderType As String) As Integer
Public Declare Function startSynchronization Lib "winmainclientdll.dll" ( _
            ByVal isSlow As String, ByVal folderType As String, ByVal path As String) As String
Public Declare Function printLog Lib "winmainclientdll.dll" (ByVal log As String, ByVal level As String) As Integer
Public Declare Function openLog Lib "winmainclientdll.dll" (ByVal path As String) As Integer
Public Declare Function closeLog Lib "winmainclientdll.dll" () As Integer
'Public Declare Function endSynchronization Lib "winmainclientdll.dll" (ByVal xmlMapping As String) As Integer

Public Declare Function freeMemAlloc Lib "winmainclientdll.dll" () As Integer
'write in outlook key in registry configuration
Public Declare Function saveOutlookConfig Lib "winmainclientdll.dll" (ByVal propertyName As String, ByVal propertyValue As String) As Long
'read parameter configuration from syncml key in registry configuration
Public Declare Function getServerConfigParameter Lib "winmainclientdll.dll" (ByVal propertyName As String, ByVal propertyValue As String, ByVal propSize As Long) As Long
Public Declare Function setServerConfigParameters Lib "winmainclientdll.dll" ( _
        ByVal syncURL As String, ByVal serverName As String, ByVal username As String, _
        ByVal password As String, ByVal deviceId As String) As Long

Public Declare Function getSourceSync Lib "winmainclientdll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal propertyValue As String, ByVal propSize As Long) As Long
Public Declare Function setSourceSync Lib "winmainclientdll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal propertyValue As String) As Long
Public Declare Function getDayLight Lib "winmainclientdll.dll" () As Long
Public Declare Function getClientConfiguration Lib "winmainclientdll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal propertyValue As String, ByVal propSize As Long) As Long
Public Declare Function setClientConfiguration Lib "winmainclientdll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal propertyValue As String) As Long
Public Declare Function isAnotherWindow Lib "winmainclientdll.dll" () As Long
Public Declare Function createSyncManager Lib "winmainclientdll.dll" () As Long
Public Declare Function deleteSyncManager Lib "winmainclientdll.dll" () As Long

'for scheduler
Public Declare Function createTask Lib "winmainclientdll.dll" (ByVal Frequency As String, _
                         ByVal StartHour As String, _
                         ByVal StartMinute As String, _
                         ByVal StartDay As String, _
                         ByVal StartMonth As String, _
                         ByVal StartYear As String, _
                         ByVal DayNum As String, _
                         ByVal MinNum As String) As Long
Public Declare Function updateTask Lib "winmainclientdll.dll" (ByVal Frequency As String, _
                         ByVal StartHour As String, _
                         ByVal StartMinute As String, _
                         ByVal StartDay As String, _
                         ByVal StartMonth As String, _
                         ByVal StartYear As String, _
                         ByVal DayNum As String, _
                         ByVal MinNum As String) As Long
Public Declare Function getTask Lib "winmainclientdll.dll" (ByVal Frequency As String, _
                         ByVal StartHour As String, _
                         ByVal StartMinute As String, _
                         ByVal StartDay As String, _
                         ByVal StartMonth As String, _
                         ByVal StartYear As String, _
                         ByVal DayNum As String, _
                         ByVal MinNum As String, _
                         ByVal Status As String, _
                         ByVal propSize As Long) As Long
Public Declare Function deleteTask Lib "winmainclientdll.dll" () As Long
    
    
    
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

'The WideCharToMultiByte function maps a wide-character string to a new character string.
'The function is faster when both lpDefaultChar and lpUsedDefaultChar are NULL.

'CodePage
Private Const CP_ACP = 0 'ANSI
Private Const CP_MACCP = 2 'Mac
Private Const CP_OEMCP = 1 'OEM
Private Const CP_UTF7 = 65000
Private Const CP_UTF8 = 65001

'dwFlags
Private Const WC_NO_BEST_FIT_CHARS = &H400
Private Const WC_COMPOSITECHECK = &H200
Private Const WC_DISCARDNS = &H10
Private Const WC_SEPCHARS = &H20 'Default
Private Const WC_DEFAULTCHAR = &H40

Public Declare Function WideCharToMultiByte Lib "kernel32" (ByVal CodePage As Long, _
                                                    ByVal dwFlags As Long, _
                                                    ByVal lpWideCharStr As Long, _
                                                    ByVal cchWideChar As Long, _
                                                    ByVal lpMultiByteStr As Long, _
                                                    ByVal cbMultiByte As Long, _
                                                    ByVal lpDefaultChar As Long, _
                                                    ByVal lpUsedDefaultChar As Long) As Long
    
    
    
    
Public objOutlook As Outlook.Application
    
'xp style
Public Declare Sub InitCommonControls Lib "comctl32.dll" ()


Public dayLight As Long
Public isOutlookInitialized As Boolean

' the variables is used to understand if a calendar is all day event.
' if so, the end day must be decremented of a day
Public isAllDayEvent As Boolean

Public OSVersion As String

Public containsNewItems As Integer
'Public newItems() As String --> not used this. Please see to mdVariables.createdList

Public modItems() As String
Public containsModItems As Integer

Public delItems() As String
Public containsDelItems As Integer

Public droppedItems As Integer

Public tempReturnedMessage As String
Public Const SYNC_CONTACTS As String = "sync.contacts"
Public Const SYNC_APPOINTMENTS As String = "sync.appointments"
Public Const SYNC_TASKS As String = "sync.tasks"
Public Const SYNC_NOTES As String = "sync.notes"

Public Const TAG_START_CONTACTS As String = "<contacts>"
Public Const TAG_END_CONTACTS As String = "</contacts>"
Public Const TAG_START_CONTACT As String = "<contact>"
Public Const TAG_END_CONTACT As String = "</contact>"

Public Const TAG_START_TASKS As String = "<tasks>"
Public Const TAG_END_TASKS As String = "</tasks>"
Public Const TAG_START_TASK As String = "<task>"
Public Const TAG_END_TASK As String = "</task>"

Public Const TAG_START_NOTES As String = "<notes>"
Public Const TAG_END_NOTES As String = "</notes>"
Public Const TAG_START_NOTE As String = "<note>"
Public Const TAG_END_NOTE As String = "</note>"

Public Const TAG_START_CALENDARS As String = "<calendars>"
Public Const TAG_END_CALENDARS As String = "</calendars>"
'Public Const TAG_START_CALENDAR As String = "<calendar>"
'Public Const TAG_END_CALENDAR As String = "</calendar>"
'Public Const ROOT_NAME = "calendar"
'IMPORTANT: modify ROOT_NAME variable too...

Public Const ROOT_CAL_NAME = "appointment"
Public Const TAG_START_CALENDAR As String = "<appointment>"
Public Const TAG_END_CALENDAR As String = "</appointment>"


Public Const SPDM_USERNAME = "spdm.username"
Public Const SPDM_PASSWORD = "spdm.password"
Public Const SPDM_SERVERNAME = "spdm.serverName"
Public Const SPDM_SYNCURL = "spdm.syncURL"
Public Const SPDM_DEVICEID = "spdm.deviceId"
Public Const NONE = "none"
Public Const TWO_WAY = "two-way"
Public Const SYNCCONTACTS = "sync.contacts"
Public Const SYNCAPPOINTMENTS = "sync.appointments"
Public Const SYNCTASKS = "sync.tasks"
Public Const SYNCNOTES = "sync.notes"

'extra propertis
Public Const PROPERTY_SOURCE_SHOW = "spdm.show"
Public Const PROPERTY_REMOTE = "spdm.showRemoteSettings"
Public Const PROPERTY_LOG_LEVEL = "spdm.logLevel"

Public Const PROPERTY_SOURCE_SYNC = "sync"
Public Const PROPERTY_SOURCE_REMOTEURI = "uri"
Public Const DIM_VALUE = 128

Public Const CONF_SAVE_SUCCESFULLY = "Configuration saved successfully"
Public Const CONF_NOT_SAVE_SUCCESFULLY = "Configuration not saved."

Public Const WAITLABEL_CAPTION_W = "Please wait: synchronization in progress..."
Public Const WAITLABEL_CAPTION_END = "Synchronization successfully completed!"
Public Const WAITLABEL_CAPTION_COMPLETED_WITH_ERROR = "Synchronization completed with errors"
Public Const WAITLABEL_CAPTION_DROPPED = "Sync completed. Some items dropped. See log."
Public Const LOGO_BMP = "logo.bmp"
Public Const ARROWS_BMP = "arrows_sync.bmp"
Public Const ARROWSWAIT_BMP = "arrows_pleasewait.bmp"
Public Const DIR_IMAGES = "images"
Public Const ICO = "fsc.ico"
Public Const WAITLABEL_CAPTION_ERR_ENDING_SYNC = "Error in completing sync..."
Public Const SYNC_CLIENT_OUTLOOK = "Sync4j Outlook Client"
Public Const EXIT_BUTTON = "Synchronize"
Public Const EXIT_BUTTON_WAIT = "Please wait..."
Public Const WAITLABEL_NO_SOURCE_TO_SYNC = "No sources to sync. Please check sync settings..."

'FormAbout

Public Const ABOUT_PRODUCT_NAME = "Sync4j Outlook Client v. "
Public Const ABOUT_FUNAMBOL = "www.sync4j.org"
Public Const ABOUT_COPYRIGHT = "Copyright (c) 2003 - 2005 Funambol."
Public Const ABOUT_RESERVED = "All rights reserved."


'Returned Error Messages. Same codes like in scapi's Constants.h
Public Const ERR_TPCIP_INIT = 2000
Public Const ERR_CONNECT = 2001
Public Const ERR_READING_CONTENT = 2002
Public Const ERR_HTTP = 2003
Public Const ERR_HTTP_MISSING_CONTENT_LENGTH = 2004
Public Const ERR_RESP_URI_DIFFERS_FROM_URL = 2008

Public Const ERR_PROTOCOL_ERROR = 400
Public Const ERR_AUTH_NOT_AUTHORIZED = 401
Public Const ERR_AUTH_EXPIRED = 402
Public Const ERR_NOT_FOUND = 404
Public Const ERR_AUTH_REQUIRED = 407
Public Const ERR_SRV_FAULT = 500
Public Const ERR_GENERIC_FAULT = 511

Public Const MSG_ERR_CONNECT = "Error connecting to the server."
Public Const MSG_ERR_ERR_HTTP = "Error finding the resource. Check server URL"
Public Const MSG_ERR_PROTOCOL_ERROR = "Protocol Error. Check server URL"
Public Const MSG_ERR_READING_CONTENT = "Error reading content. Server unavailable"
Public Const MSG_ERR_AUTH_REQUIRED = "Not authorized. Check user/password properties"
Public Const MSG_ERR_AUTH_EXPIRED = "Account expired."
Public Const MSG_ERR_SRV_FAULT = "Server error"
Public Const MSG_ERR_NOT_FOUND = "Server returned source NOT FOUND. Check Synchronization Settings - Remote Name property."
Public Const MSG_ERR_GENERIC = "Synchronization NOT completed."
Public Const MSG_ERR_RESP_URI_DIFFERS_FROM_URL = "Error reconnecting to the server. "

Public Const DEBUG_LEVEL = "DEBUG"
Public Const INFO_LEVEL = "INFO"
Public Const ERROR_LEVEL = "ERROR"

Public Const ERROR_INSERTING_NEW_ITEM = "Error in inserting a new item. Element dropped: "
Public Const ERROR_INSERTING_UPDATE_ITEM_AS_NEW = "Updated item should be inserted as new. The client will respond 500 to the server. Currently the item is dropped."
Public Const ERROR_UPDATING_ITEM = "Error in updating the item: "


'FormScheduler
Public Const NEVER = "Never"
Public Const EVERY_DAY = "Every day"
Public Const NO_TASK = "No task"
Public Const CUSTOM_TASK = "Custom task"
Public Const NO_TASK_SCHEDULED = "No task scheduled"
Public Const EXTERNAL_CUSTOMIZE_TASK = "Not supported schedule. Default settings will be restored"
Public Const TASK_DISABLED = "Task disabled"
Public Const ACCOUNT_PASSWORD_REQUIRED = "Account password is required"
Public Const ACCOUNT_NAME_REQUIRED = "Account name is required"
Public Const EVERY_MINUTES = "Please set a value < of 1440 (24h)"
Public Const EVERY_DAYS = "Please set a value"

'Messages for syncing
Public Const WAIT_PREPARING = "Please wait: preparing "
Public Const WAIT_SENDING_DATA = "Please wait: sending and receiving data..."
Public Const WAIT_ENDING_SYNC = "Please wait: ending sync..."

Public Const WAIT_READING_ALL = "Please wait: reading "
Public Const WAIT_READING_NEW = "Please wait: reading new "
Public Const WAIT_READING_MOD = "Please wait: reading update "
Public Const WAIT_READING_DEL = "Please wait: reading delete "

Public Const WAIT_PROCESSING_UPDATE = "Please wait: processing update "
Public Const WAIT_PROCESSING_INSERT = "Please wait: processing insert "
Public Const WAIT_PROCESSING_DELETE = "Please wait: processing delete "
Public Const WAIT_SYNCING_CON = "Please wait: synchronizing Contacts "
Public Const WAIT_SYNCING_CAL = "Please wait: synchronizing Calendar "
Public Const WAIT_SYNCING_TASK = "Please wait: synchronizing Task "
Public Const WAIT_SYNCING_NOTE = "Please wait: synchronizing Notes "



Public Const WAIT_PREPARING_NEW = "Please wait: preparing new "
Public Const WAIT_PREPARING_UPDATE = "Please wait: preparing update "
Public Const WAIT_PREPARING_DELETE = "Please wait: preparing delete "

Public Const DIR_ALL_ITEM_CONTACTS = "AllItemContacts"
Public Const DIR_ALL_ITEM_CALENDARS = "AllItemCalendars"
Public Const DIR_ALL_ITEM_TASKS = "AllItemTasks"
Public Const DIR_ALL_ITEM_NOTES = "AllItemNotes"

Public Const DIR_NEW_ITEM_CONTACTS = "NewItemContacts"
Public Const DIR_NEW_ITEM_CALENDARS = "NewItemCalendars"
Public Const DIR_NEW_ITEM_TASKS = "NewItemTasks"
Public Const DIR_NEW_ITEM_NOTES = "NewItemNotes"

Public Const DIR_MOD_ITEM_CONTACTS = "ModItemContacts"
Public Const DIR_MOD_ITEM_CALENDARS = "ModItemCalendars"
Public Const DIR_MOD_ITEM_TASKS = "ModItemTasks"
Public Const DIR_MOD_ITEM_NOTES = "ModItemNotes"

Public Const SERVER_ITEMS = "ServerItems.txt"



Public Function getVersion() As String
'Calculate the complete path of the application
        
    Dim sVersion As String
    sVersion = App.Major & "." & App.Minor & "." & App.Revision
    getVersion = sVersion
End Function

Public Sub ChangeStatusBar(ByVal message As String)
    frmMMSync.StatusBar1.SimpleText = message
    frmMMSync.StatusBar1.Refresh

End Sub

Public Sub deleteDirectory(ByVal dirName As String)
    If mdFileSystem.doesFolderExist(dirName) Then
        ChDir dirName
        On Error Resume Next
        
            Kill "*.*"
        On Error GoTo 0
        ChDir ".."
        logToDebug CurDir
        logToDebug mdMMVariables.AppPath() + dirName
        On Error Resume Next
            RmDir mdMMVariables.AppPath() + dirName
        On Error GoTo 0
    End If

End Sub


Public Function replaceMinorAndMajorAndAmp(ByVal element As String)
    
    
    If element <> Empty And element <> "" Then
        If InStr(element, "<") <> 0 Or InStr(element, ">") <> 0 Or InStr(element, "&") <> 0 Then
            Dim ret As String
            ret = ReplaceAll(element, "&", "&amp;")
            ret = ReplaceAll(ret, "<", "&lt;")
            ret = ReplaceAll(ret, ">", "&gt;")
            replaceMinorAndMajorAndAmp = ret
        Else
            replaceMinorAndMajorAndAmp = element
        End If
    Else
        replaceMinorAndMajorAndAmp = element
    End If
    

End Function

Public Function replaceMinorAndMajorAndAmpFromServer(ByVal element As String)
    
    
    If element <> Empty And element <> "" Then
        If InStr(element, "<") <> 0 Or InStr(element, ">") <> 0 Or InStr(element, "&") <> 0 Then
            Dim ret As String
            ret = ReplaceAll(element, "&amp;", "&")
            ret = ReplaceAll(ret, "&lt;", "<")
            ret = ReplaceAll(ret, "&gt;", ">")
            replaceMinorAndMajorAndAmpFromServer = ret
        Else
            replaceMinorAndMajorAndAmpFromServer = element
        End If
    Else
        replaceMinorAndMajorAndAmpFromServer = element
    End If
    

End Function



Public Function AppPath() As String
'Calculate the complete path of the application
    
    
    Dim path
    Dim drive As String
    
    path = App.path
    If path = "\" Then
        AppPath = "\"
    Else
        drive = Left(path, 1)
        ChDrive (drive)
        AppPath = path & "\"
    End If
    
End Function

Public Function AppDrive() As String
'get the drive in which the application is stored
        
    Dim path
    Dim drive As String
    path = AppPath()
    drive = Left(path, 1)
    AppDrive = drive
    
    
End Function





Public Function isPropertyInRecurrenceObject(ByVal element As String)
 If element = "RecurrenceType" _
        Or element = "Interval" _
        Or element = "MonthOfYear" _
        Or element = "DayOfMonth" _
        Or element = "DayOfWeekMask" _
        Or element = "Instance" _
        Or element = "PatternStartDate" _
        Or element = "PatternEndDate" _
        Or element = "NoEndDate" _
        Or element = "Occurrences" Then
        isPropertyInRecurrenceObject = True
    Else
        isPropertyInRecurrenceObject = False
    End If
    
        
End Function

Public Function isValidProperty(ByVal name As String, ByVal valueOfRecurrenceType)
    Dim ret As Boolean
    
    
    
    If name = "RecurrenceType" Then
        ret = True
    ElseIf valueOfRecurrenceType = 0 And name = "Interval" Then
        ret = True
    Else
        ret = False
        isValidProperty = ret
    End If

End Function


Function defaultNoteValues(ByVal name As String, ByVal value As String)
'<Color>3</Color><Height>166</Height><Width>200</Width><Left>110</Left><Top>110</Top>
Dim intValue As String
intValue = value

If name = "Color" Then
    If value = "" Or value = Empty Then
        intValue = 3
    End If

ElseIf name = "Height" Then
    If value = "" Or value = Empty Then
        intValue = 166
    End If
    
ElseIf name = "Width" Then
    If value = "" Or value = Empty Then
        intValue = 200
    End If
    
ElseIf name = "Left" Then
    If value = "" Or value = Empty Then
        intValue = 110
    End If
    
ElseIf name = "Top" Then
    If value = "" Or value = Empty Then
        intValue = 110
    End If
    
End If
defaultNoteValues = intValue

End Function


Function returnElementDataTypeCorrect(ByVal name As String, ByVal value As String)
    
    If name = "AllDayEvent" Or _
       name = "IsRecurring" Or _
       name = "ReminderSet" Or _
       name = "NoEndDate" Or _
       name = "TeamTask" Or _
       name = "NoAging" Or _
       name = "IsOnlineMeeting" Or _
       name = "Complete" Then
        Dim tmpbool As Boolean
        If value <> Empty And value <> "" Then
            If (CBool(value) = True Or CStr(value) = "1" Or CStr(value) = "True") Then
                tmpbool = True
            Else
                tmpbool = False
            End If
        Else
            tmpbool = False
        End If
        returnElementDataTypeCorrect = tmpbool
        Exit Function
    
    ElseIf name = "BusyStatus" Then
        If value = "" Then
            returnElementDataTypeCorrect = Val("2") 'busy default value
        Else
            returnElementDataTypeCorrect = Val(value)
        End If
        Exit Function
    
    ElseIf name = "RecurrenceType" Or name = "Importance" Or name = "MeetingStatus" _
        Or name = "ReminderMinutesBeforeStart" Or name = "Interval" Or name = "MonthOfYear" _
        Or name = "DayOfMonth" Or name = "DayOfWeekMask" Or name = "Instance" Or name = "ReplyTime" _
        Or name = "Sensitivity" Or name = "Duration" Or name = "Occurrences" Then
                        
        If value = "" Then
            returnElementDataTypeCorrect = Val("0")
        Else
            returnElementDataTypeCorrect = Val(value)
        End If
        Exit Function
    
    ElseIf name = "PatternStartDate" _
        Or name = "PatternEndDate" _
        Or name = "DateCompleted" Or name = "DueDate" Or name = "StartDate" _
        Or name = "ReminderTime" Then
        
        If value = "" Then
            returnElementDataTypeCorrect = Empty
        Else
            If IsDate(mdMMTimeUtils.dateToCanonical(value)) Then
                If InStr(value, "Z") <> 0 Then
                    returnElementDataTypeCorrect = mdMMTimeUtils.UTCToLocal(CDate(mdMMTimeUtils.dateToCanonical(value)))
                Else
                    returnElementDataTypeCorrect = CDate(mdMMTimeUtils.dateToCanonical(value))
                End If
            Else
            
            End If
        End If
        Exit Function
    
    'Used for the AllDayEvent modification for calendar
    ElseIf name = "Start" Or name = "End" Then
        If value = "" Then
            returnElementDataTypeCorrect = Empty
        Else
            If IsDate(mdMMTimeUtils.dateToCanonical(value)) Then
                If InStr(value, "Z") <> 0 Then
                    returnElementDataTypeCorrect = mdMMTimeUtils.UTCToLocal(CDate(mdMMTimeUtils.dateToCanonical(value)))
                Else
                    returnElementDataTypeCorrect = CDate(mdMMTimeUtils.dateToCanonical(value))
                End If
            ElseIf name = "Start" And IsDate(mdMMTimeUtils.dateToCanonicalBirth(value)) And mdMMVariables.isAllDayEvent = True Then
                returnElementDataTypeCorrect = CDate(mdMMTimeUtils.dateToCanonicalBirth(value))
            ElseIf name = "End" And IsDate(mdMMTimeUtils.dateToCanonicalBirth(value)) And mdMMVariables.isAllDayEvent = True Then
                Dim td As Date
                td = CDate(value)
                td = DateAdd("d", 1, td)
                returnElementDataTypeCorrect = td
            End If
        End If
        Exit Function
    
    ElseIf name = "Birthday" Or name = "Anniversary" Then
        If value = "" Then
            returnElementDataTypeCorrect = Empty
        Else
            If IsDate(mdMMTimeUtils.dateToCanonical(value)) Then
                returnElementDataTypeCorrect = CDate(mdMMTimeUtils.dateToCanonical(value))
            ElseIf IsDate(mdMMTimeUtils.dateToCanonicalBirth(value)) Then
                returnElementDataTypeCorrect = CDate(mdMMTimeUtils.dateToCanonicalBirth(value))
            Else
            
            End If
        End If
        Exit Function
    
    End If
    
    returnElementDataTypeCorrect = value
End Function

Public Function isChanged(ByRef folderInfoArray() As FolderInfo)
     
    Dim I As Integer
     
    For I = 1 To UBound(folderInfoArray)
        If folderInfoArray(I).Changed Then 'if changed = True create the folder
            isChanged = "True"
            Exit Function
        Else
            isChanged = "False"
            Exit Function
        End If
    Next I
    
End Function


Public Sub consolidatePreferences(ByRef folderInfoArray() As FolderInfo)
     
    Dim I As Integer
     
    For I = 1 To UBound(folderInfoArray)
        folderInfoArray(I).Changed = False
    Next I
    
End Sub

Function getElementContent(ByRef xml As String, ByVal tag As String, ByRef position)
    'position passato per riferimento. prima di uscire, settato al valore in cui finisce il tag.
    
    Dim openTag As String
    Dim closeTag As String
    Dim startInt As Long
    Dim endInt As Long
    Dim containsShortCloseTag As Integer
    Dim pos As Long
    Dim shortCloseTag As String
    Dim I As Integer
    Dim found As Boolean
    found = False
    
    Dim tmpl As String
    tmpl = ""
    Dim tmpr As String
    tmpr = ""
    
    If (position = Null Or position = 0) Then
        pos = 1
    Else
        pos = position
    End If
    
    
    Dim res As String
    
    openTag = "<" + tag + ">"
    closeTag = "</" + tag + ">"
    shortCloseTag = "<" + tag + "/>"
        
        
    startInt = InStr(pos, xml, openTag)
    
    
    If startInt = 0 Then   'There isn't tag
    
        containsShortCloseTag = InStr(pos, xml, shortCloseTag)
        If containsShortCloseTag <> 0 Then
            'getElementContent = Empty ' "" 'If tag <tag/> return ""
            getElementContent = ""
            Exit Function
        Else
            openTag = "<" + tag
            startInt = InStr(pos, xml, openTag)
            
            If startInt = 0 Then
                getElementContent = Empty
                Exit Function
            End If
            
            startInt = startInt + Len(openTag)
            For I = 0 To Len(xml)
                If found = False Then
                    startInt = startInt + 1
                    tmpl = Left(xml, startInt)
                    tmpr = Right(tmpl, 1)
                    If tmpr = ">" Then
                        startInt = startInt + 1
                        found = True
                    End If
                End If
            Next I
                        
            'getElementContent = Empty ' "" 'If there is return "". in the future I could like to change values...
            'Exit Function
        End If
        
        
    Else
        startInt = startInt + Len(openTag)
        found = True
    End If
    
    If found = False Then
        getElementContent = Empty ' "" 'If there is return "". in the future I could like to change values...
        Exit Function
    Else
        endInt = InStr(pos, xml, closeTag)
        If endInt = 0 Then
            getElementContent = "-1" 'Error xml not well formed
            Exit Function
        Else
            'nothing to do. All right
        End If
       
    End If
    
    
    Dim initContent As Long
    
    initContent = startInt
    
    res = Mid(xml, initContent, endInt - initContent)
    
    If position <> 0 Then
        position = endInt + Len(closeTag)
    End If
    
    If res = "" Then
        'getElementContent = Empty
        getElementContent = res
    Else
        getElementContent = res
    End If

End Function


Function IsOutlookProcessRunning()
    Dim Process, strObject
    Dim proce As String
    proce = "OUTLOOK.EXE"
    IsOutlookProcessRunning = False
    strObject = "winmgmts://localhost"
    For Each Process In GetObject(strObject).InstancesOf("win32_process")
    If UCase(Process.name) = UCase(proce) Then
            IsOutlookProcessRunning = True
            Exit Function
        End If
    Next
End Function


Function ReplaceAll(SourceString As String, ReplaceThis As String, WithThis As String)
    Dim temp As Variant
    temp = Split(SourceString, ReplaceThis)
    ReplaceAll = Join(temp, WithThis)
End Function

Function getAllNameFolderFromFile()
    'used for deleted items that are into folder.preferences but no more into outlook

Dim readingLIne As String
Dim readingArray() As String
Dim readingFolders() As String
'Dim deletedFolders() As String
Dim deletedItems() As String

Dim found As Boolean
found = False
Dim I, J As Integer
Dim dimension, arrayDimension As Long
dimension = -1

Dim commentHere As Integer
Dim filename As String
filename = mdVariables.NAME_PREFERENCES_FILE

On Error GoTo getAllNameFolderFromFile_Err

'to count how many selected folders in preferences fil

Open filename For Input As #1
Do While Not EOF(1)
    Line Input #1, readingLIne
    If Len(readingLIne) > 0 Then
        'cut the spaces at the beginning of the line
        Do While Left(readingLIne, 1) = " "
            readingLIne = Right(readingLIne, Len(readingLIne) - 1)
        Loop
        'search for the comment lines
        commentHere = InStr(readingLIne, "||")
        'if the comment is not at the beginning of the line
        If commentHere > 1 Then
            'cut the comment part from a string
            readingLIne = Left(readingLIne, commentHere - 1)
        End If
        If Len(readingLIne) > 0 And InStr(readingLIne, "=") Then
            'the first split divides the property-head of the line from the content
            readingArray = Split(readingLIne, "=")
            If Len(readingArray(1)) > 0 Then 'if the property-list part of the line is not empty
                If InStr(readingArray(0), "folder") Then 'Case "folder" written in the property-head part of line
                    
                    If InStr(readingArray(0), "Contacts") Then
                         Exit Do
                    
                    End If
                End If
            End If
        End If
    End If
Loop
Close #1

readingFolders = Split(readingArray(1), ",") 'create the EntryID array for the selected folders

For I = 0 To UBound(readingFolders)
    logToDebug "readingArray(I):" & readingFolders(I)
    For J = 1 To UBound(mdVariables.contactsFolders)
        If readingFolders(I) = mdVariables.contactsFolders(J).EntryID Then
            found = True
            Exit For
        End If
    Next J
    If found = False Then
        dimension = dimension + 1
        ReDim Preserve mdVariables.deletedFolders(dimension)
        mdVariables.deletedFolders(dimension) = readingFolders(I)
    End If
    found = False
Next I

I = 0
arrayDimension = dimension
dimension = -1


For I = 0 To arrayDimension
    If mdFileSystem.doesFolderExist(mdVariables.deletedFolders(I)) Then
        
        ChDir mdVariables.deletedFolders(I)
        If mdFileSystem.doesFileExist(mdVariables.NAME_OLD_FILE) Then
            Open mdVariables.NAME_OLD_FILE For Input As #1
            Line Input #1, readingLIne
            Line Input #1, readingLIne
            Do While Not EOF(1)
                Line Input #1, readingLIne
                dimension = dimension + 1
                ReDim Preserve deletedItems(dimension)
                readingLIne = Mid(readingLIne, 2, Len(readingLIne) - 2)
                
                deletedItems(dimension) = readingLIne
                logToDebug "deletedItems" & deletedItems(dimension)
                
            Loop
            Close #1
        End If
        ChDir ".."
    
    End If
    
Next I

getAllNameFolderFromFile = deletedItems

getAllNameFolderFromFile_Exit:
    Exit Function

getAllNameFolderFromFile_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getAllNameFolderFromFile_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Function


Function getAllNewItemNameFromFile()
    'used for deleted items that are into folder.preferences but no more into outlook

Dim readingLIne As String
Dim folderPath As String
Dim readingArray() As String
Dim readingFolders() As String
Dim newFolders() As String
Dim newItems() As Variant
Dim commentHere As Integer

Dim found As Boolean
found = False
Dim I, J As Integer
Dim dimension, arrayDimension As Long
dimension = -1

Dim filename As String
filename = mdVariables.NAME_PREFERENCES_FILE

On Error GoTo getAllNewItemNameFromFile_Err

'to count how many selected folders in preferences fil

Open filename For Input As #1
Do While Not EOF(1)
    Line Input #1, readingLIne
    If Len(readingLIne) > 0 Then
        'cut the spaces at the beginning of the line
        Do While Left(readingLIne, 1) = " "
            readingLIne = Right(readingLIne, Len(readingLIne) - 1)
        Loop
        'search for the comment lines
        commentHere = InStr(readingLIne, "||")
        'if the comment is not at the beginning of the line
        If commentHere > 1 Then
            'cut the comment part from a string
            readingLIne = Left(readingLIne, commentHere - 1)
        End If
        If Len(readingLIne) > 0 And InStr(readingLIne, "=") Then
            'the first split divides the property-head of the line from the content
            readingArray = Split(readingLIne, "=")
            If Len(readingArray(1)) > 0 Then 'if the property-list part of the line is not empty
                If InStr(readingArray(0), "folder") Then 'Case "folder" written in the property-head part of line
                    
                    If InStr(readingArray(0), "Contacts") Then
                         Exit Do
                    
                    End If
                End If
            End If
        End If
    End If
Loop
Close #1

readingFolders = Split(readingArray(1), ",") 'create the EntryID array for the selected folders

For I = 1 To UBound(mdVariables.contactsFolders)
    logToDebug "readingArray(I):" & mdVariables.contactsFolders(I).EntryID
    For J = 0 To UBound(readingFolders)
        If mdVariables.contactsFolders(I).EntryID = readingFolders(J) Then
            found = True
            Exit For
        End If
    Next J
    If found = False Then
        dimension = dimension + 1
        ReDim Preserve newFolders(dimension)
        newFolders(dimension) = mdVariables.contactsFolders(I).EntryID
    End If
    found = False
Next I

I = 0
arrayDimension = dimension
dimension = -1


For I = 0 To arrayDimension
    If mdFileSystem.doesFolderExist(newFolders(I)) Then
        
        ChDir newFolders(I)
        If mdFileSystem.doesFileExist(mdVariables.NAME_CRE_FILE) Then
            Open mdVariables.NAME_CRE_FILE For Input As #1
            Line Input #1, readingLIne
            Line Input #1, folderPath
            folderPath = Mid(folderPath, 2, Len(folderPath) - 2)
            
            Do While Not EOF(1)
                Line Input #1, readingLIne
                dimension = dimension + 1
                
                readingLIne = Mid(readingLIne, 2, Len(readingLIne) - 2)
                
                ReDim Preserve newItems(0 To 1, 0 To dimension)
                newItems(0, dimension) = readingLIne
                newItems(1, dimension) = folderPath
                
                logToDebug "readingNewLine" & newItems(0, dimension)
                
            Loop
            Close #1
        End If
        ChDir ".."
    
    End If
    
Next I

getAllNewItemNameFromFile = newItems

getAllNewItemNameFromFile_Exit:
    Exit Function

getAllNewItemNameFromFile_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getAllNewItemNameFromFile_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Function

Public Function convertDayOfWeekMaskBackward(ByVal dayOfWeekMaskSent As Integer)
    Dim dayOfWeekMask As Integer
    dayOfWeekMask = 0
    
    If ((dayOfWeekMaskSent Mod 2) <> 0) Then
        dayOfWeekMask = mdMMShiftBit.LShift(dayOfWeekMaskSent, 1)
        dayOfWeekMask = dayOfWeekMask + 64
        convertDayOfWeekMaskBackward = dayOfWeekMask
    Else
    
        convertDayOfWeekMaskBackward = mdMMShiftBit.LShift(dayOfWeekMaskSent, 1)
    End If
    
End Function

Public Function convertDayOfWeekMaskForward(ByVal dayOfWeekMaskSent As Integer)
    Dim dayOfWeekMask As Integer
    dayOfWeekMask = 0
    
    If dayOfWeekMaskSent >= 64 Then
        dayOfWeekMask = mdMMShiftBit.RShift(dayOfWeekMaskSent, 1)
        dayOfWeekMask = dayOfWeekMask - 127
        convertDayOfWeekMaskForward = dayOfWeekMask
    Else
        convertDayOfWeekMaskForward = mdMMShiftBit.RShift(dayOfWeekMaskSent, 1) '<<
    End If
    
End Function

Public Sub printDebugMessage(ByVal value As String)
    printLog value, DEBUG_LEVEL
End Sub

'Place code in a form module
'Add a Command button.

Public Function ByteArrayToString(Bytes() As Byte) As String
    Dim iUnicode As Long, I As Long, J As Long
    
    On Error Resume Next
    I = UBound(Bytes)
    
    If (I < 1) Then
        'ANSI, just convert to unicode and return
        ByteArrayToString = StrConv(Bytes, vbUnicode)
        Exit Function
    End If
    I = I + 1
    
    'Examine the first two bytes
    CopyMemory iUnicode, Bytes(0), 2
    
    If iUnicode = Bytes(0) Then 'Unicode
        'Account for terminating null
        If (I Mod 2) Then I = I - 1
        'Set up a buffer to recieve the string
        ByteArrayToString = String$(I / 2, 0)
        'Copy to string
        CopyMemory ByVal StrPtr(ByteArrayToString), Bytes(0), I
    Else 'ANSI
        ByteArrayToString = StrConv(Bytes, vbUnicode)
    End If
                    
End Function

Public Function StringToByteArray(strInput As String, _
                                Optional bReturnAsUnicode As Boolean = True, _
                                Optional bAddNullTerminator As Boolean = False) As Byte()
    
    Dim lRet As Long
    Dim bytBuffer() As Byte
    Dim lLenB As Long
    
    If bReturnAsUnicode Then
        'Number of bytes
        lLenB = LenB(strInput)
        'Resize buffer, do we want terminating null?
        If bAddNullTerminator Then
            ReDim bytBuffer(lLenB)
        Else
            ReDim bytBuffer(lLenB - 1)
        End If
        'Copy characters from string to byte array
        CopyMemory bytBuffer(0), ByVal StrPtr(strInput), lLenB
    Else
        'METHOD ONE
'        'Get rid of embedded nulls
'        strRet = StrConv(strInput, vbFromUnicode)
'        lLenB = LenB(strRet)
'        If bAddNullTerminator Then
'            ReDim bytBuffer(lLenB)
'        Else
'            ReDim bytBuffer(lLenB - 1)
'        End If
'        CopyMemory bytBuffer(0), ByVal StrPtr(strInput), lLenB
        
        'METHOD TWO
        'Num of characters
        lLenB = Len(strInput)
        If bAddNullTerminator Then
            ReDim bytBuffer(lLenB)
        Else
            ReDim bytBuffer(lLenB - 1)
        End If
        lRet = WideCharToMultiByte(CP_ACP, 0&, ByVal StrPtr(strInput), -1, ByVal VarPtr(bytBuffer(0)), lLenB, 0&, 0&)
        'lRet = WideCharToMultiByte(28591, 0&, ByVal StrPtr(strInput), -1, ByVal VarPtr(bytBuffer(0)), lLenB, 0&, 0&)

    End If
    
    StringToByteArray = bytBuffer
    
End Function


